package org.netkernel.rdbms.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.rdbms.representation.ResultSetRepresentation;
import org.netkernel.rdbms.util.RDBMSUtil;

import java.sql.ResultSet;

public class ResultSetRepresentationToHDSTransreptor extends StandardTransreptorImpl
{
	public ResultSetRepresentationToHDSTransreptor()
	{	this.declareThreadSafe();
		this.declareToRepresentation(IHDSNode.class);
	}

	public void onTransrept(INKFRequestContext context) throws Exception
	{	ResultSetRepresentation rsp=context.sourcePrimary(ResultSetRepresentation.class);
		ResultSet resultSet=rsp.getResultSet();
		HDSBuilder builder=new HDSBuilder();
		RDBMSUtil.resultsetToHDS(builder, resultSet);
		context.createResponseFrom(builder.getRoot());
	}
}
