package org.netkernel.rdbms.endpoint;

import org.netkernel.layer0.nkf.*;
import org.netkernel.layer0.urii.ValueSpace;
import org.netkernel.module.standard.endpoint.TransparentOverlayImpl;
import org.netkernel.rdbms.representation.ConnectionPoolAspect;
import org.netkernel.rdbms.representation.IAspectDBConnectionPool;

public class SQLTransactionOverlay extends TransparentOverlayImpl
{
	public SQLTransactionOverlay()
	{	this.declareThreadSafe();		
	}
	
	public void onRequest(String elementId, INKFRequestContext aContext) throws Exception
	{	String configIdentifier=(String)getParameter("configuration");
		ConnectionPoolAspect connectionPool=aContext.source(configIdentifier,ConnectionPoolAspect.class);
		IAspectDBConnectionPool transactedConnectionPool=connectionPool.getTransactedConnection();
		ValueSpace vs=new ValueSpace(1);
		vs.put(configIdentifier, transactedConnectionPool, null);
		INKFRequest requestOut=aContext.getThisRequest().getIssuableClone();
		requestOut.injectDurableRequestScope(vs);
		boolean commit=false;
		try
		{	INKFResponseReadOnly<?> respIn=aContext.issueRequestForResponse(requestOut);
			aContext.createResponseFrom(respIn);
			connectionPool.commitConnection(transactedConnectionPool);
			commit=true;
		}
		finally
		{	if (!commit)
			{	connectionPool.rollbackConnection(transactedConnectionPool);
			}
		}
	}

}
